package WebFlow.Charon;

import org.omg.CORBA.*;
import WebFlow.*;
import WebFlow.event.*;
//import WebFlow.QS.*;
import WebFlow.hashtable.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;


/////Added////////////////////
import orbasec.corba.Opaque;
/////Added////////////////////

public class MyCharon {
    
    public ORB orb;
    public String IorURL;
    public WebFlowContext master = null;
    public WebFlowContext c1;
    public CharonServer charon;
    org.omg.CORBA.Object och,ochm;
    String TargetServer;
    ServerSocket server;
    PrintWriter out;
    BufferedOutputStream bos;
    String RequestType, RequestFile, RequestURL, RequestParameters;
    boolean binary;
    byte[] buf;

/////Added////////////////////
    org.omg.SecurityLevel2.SecurityManager security_manager= null;  
    String CharonCookieVal;
    String CharonCookieName;
/////Added////////////////////   

    org.omg.CORBA.Object o_base;
    String UserName="Nothing";  //this is the user name. should change
    String BrowserPath="netscape";   
    String servletURL;
    String startPage="/SciPortal/CharonStart.jsp";
    String UserConfDir="/a/birch.csit.fsu.edu/shared/home/cyoun/GATEWAY/apache1.3.12/WWW/SciPortal/WEB-INF/Descriptors/users/";
    String cmd_line;
    String MasterRef;
    String DISPLAY="magnolia.csit.fsu.edu:0.0";
    String MasterName="birch.csit.fsu.edu";
    String relMasterIOR="SciPortal/IOR/master.txt";
    String LocalServer;

    public ContextData ht;
    
    WebFlowContext uc=null;    //User's context object

    public MyCharon(String ior, String TargetServer,String Port) {

	LocalServer="http://localhost:"+Port;
	System.out.println(LocalServer);
	MasterRef=ior;
	this.TargetServer = TargetServer;
	servletURL=TargetServer+"/servlets/CharonStart";
	connectToMaster(ior);    //Does all the setup work.
	
	//Now open the socket on the client and listen for requests.
	try {
	    server = new ServerSocket(Integer.parseInt(Port));     
	    while (true) {
		/* listen to requests from the local web browser */
		System.out.println("waiting for requests...");
		Socket socket = server.accept();
		InetAddress host=socket.getInetAddress();
		String hostaddress = host.getHostAddress();
		if(!hostaddress.equals("127.0.0.1")) {
		    System.out.println(" ===================== ");
		    System.out.println("Warning: unauthorized access from "+hostaddress);
		    System.exit(0);
		}
 
		/* read and parse request */
		
		BufferedReader in = 
		    new BufferedReader(new InputStreamReader(socket.getInputStream()));
		String str = in.readLine();
		/* the first line should be the request */
		StringTokenizer st = new StringTokenizer(str);
		RequestType = st.nextToken();
		RequestFile = st.nextToken();
		RequestURL = TargetServer+RequestFile;

		System.out.println("request type: "+RequestType);
		System.out.println("request  url: "+RequestURL);
		
		//For kerberized Charon, html and servlet files must be
		//passed as binary.  Or maybe this is an apache thing
		//and Jigsaw can pass things as strings. --Marlon

		binary=true;  
		//if(RequestFile.endsWith(".html")) binary=false;
		//if(RequestFile.endsWith(".HTML")) binary=false;
		//if(RequestFile.endsWith(".htm")) binary=false;
		//if(RequestFile.endsWith(".HTM")) binary=false;
		//if(RequestFile.endsWith(".txt")) binary=false;
		//if(RequestFile.endsWith(".TXT")) binary=false;
		//if(RequestFile.indexOf("servlets")>-1) binary=false;

		System.out.println("binary set to "+binary);
		System.out.println("Servlet index: "
				   +RequestFile.indexOf("servlet"));
		
		/* read the request to the end */
		StringTokenizer t;
		while (!str.equals("")) {
		    try {
			str=in.readLine();
			t=new StringTokenizer(str," :=;");
			while(t.hasMoreTokens()){
			    if(t.nextToken().equals("JSESSIONID"))
				CharonCookieVal=t.nextToken();
			}
			System.out.println(str);
		    } catch (java.lang.NullPointerException e) {}
		}

		System.out.println("while completed");
		/* Add the following to handle Post requests */
		if(RequestType.equals("POST")) {
		    //read parameters
		    RequestParameters = in.readLine();
		    RequestURL += "?"+RequestParameters;
		} 

		System.out.println(CharonCookieVal);
		if(CharonCookieVal!=null){
		    charon.setSessionCookie(CharonCookieVal);
		    System.out.println("Session Value: "+charon.getSessionCookie());
		}
		
		/* open output stream to browser */	
		try {
		    OutputStream os=socket.getOutputStream();
		    if(binary) {bos = new BufferedOutputStream(os);}
		    else {out = new PrintWriter(os,true);}
		    // out = new PrintWriter(os,true);
		} catch (Exception e) {
		    System.out.println("cannot open output stream...");
		    System.out.println(e);
		}
		
		/* make request on behalf of the browser */
		
		if(charon.connect(RequestURL)){
		    try {
			if(binary) {
			    buf = charon.getBinaryBlock();
			    while(buf.length>1) {
				bos.write(buf,0,buf.length);
				bos.flush();
				buf = charon.getBinaryBlock();
			    } 
			}
			else {    
			    String nextLine = charon.getBlock();
				while(!nextLine.equals("EOF")) {
				    out.println(nextLine);
				    nextLine = charon.getBlock();
				}
			}
			//			charon.closeConnection();
			socket.close();
		    } catch (Exception e) {
			System.out.println("IO error writing back to browser");
			charon.closeConnection();
			socket.close();
			System.out.println(e);
		    }
		}
		else {
		    System.out.println("cannot open URL: "+RequestURL);
		} 
	    }  //Ends the while block.
	} 
	catch (IOException e)
	    {
		System.out.println("Conection not established with server "+e);
	    }
	master.removeModule(och);
    }
    
    public void connectToMaster(String IorURL) {
	//This method does all the setup work: initialize the orb, add the
	//charon module, set the Kerberos ID, set the cookie, and fire up
	//netscape.
	initializeORB(IorURL);
	master = getMasterServer(IorURL);

	if(master==null) {
	    System.out.println("Cannot connect to the master server");
	    return;
	}
	System.out.println("Master contacted");
       
	/* Add a slave server */
	/* Note: I have to do this remotely.*/
  	boolean slaveOn=false;
	System.out.println("look for slave...");
	org.omg.CORBA.Object[] SlaveServers2=master.toArray();
	System.out.println("slaves? "+SlaveServers2.length);
	for(int i=0; i<SlaveServers2.length; i++) {    
	    WebFlow.BeanContextChild Something=null;
	    Something=BeanContextChildHelper.narrow(SlaveServers2[i]);
	    System.out.println("..."+i);
	    if(Something.isWFServer()) {
		WebFlowContext sl=WebFlowContextHelper.narrow(SlaveServers2[i]);
		System.out.println("... got sl");
		String SlaveName = sl.getObjectID();
		System.out.println(SlaveName);
		if(SlaveName.indexOf(UserName)>-1) slaveOn=true;
	    }
	    else {
		try { 
		    ht=ContextDataHelper.narrow(SlaveServers2[i]);
		    System.out.println("ContextData found!");
		}
		catch (Exception e) {System.out.println(e);} 
	    }
	}
	
    	System.out.println("Adding a child server to the parent");
  	String ConfFile=UserConfDir+UserName+"/"+UserName+".conf";
	//  	createSlaveConf(ConfFile,UserName,MasterName);
  	startSlaveServer(ConfFile);   //Use the conf file to start a child.
	
  	//Now, while the slave is coming up, do the following voodoo 
  	//until the slave initialization is completed.
  	//--->I should make this into a method, I think.

  	org.omg.CORBA.Object[] SlaveServers1;
	System.out.println("SlaveServer1 array created");
  	String[] SlaveServers;
     	for (int j=0; j<100; j++) {
    	    SlaveServers1=master.toArray(); 
  	    System.out.println("How many slaves? "+SlaveServers1.length);
  	    if(SlaveServers1.length<1) {
  		waitForServer(10000);
  	    } else {
		for(int i=0; i<SlaveServers1.length; i++) {
		    WebFlow.BeanContextChild Something=null;
		    Something=BeanContextChildHelper.narrow(SlaveServers1[i]);
		    if(Something.isWFServer()) {            
			WebFlowContext sl=WebFlowContextHelper.narrow(SlaveServers1[i]);
			String SlaveName = sl.getObjectID();
			System.out.println("Slavename: "+SlaveName);
			if(SlaveName.indexOf(UserName)>-1) slaveOn=true;
		    }
		} 
		if(slaveOn) break;
		waitForServer(10000);
	    }     
  	}    
	
	//Now create the user context object 
	String slaveServerName=UserName+".";
	try {
	    org.omg.CORBA.Object ucobj=master.getContext(MasterName+"/"+slaveServerName);
	    uc=WebFlowContextHelper.narrow(ucobj);
	    System.out.println("Created ucobj");
	    if(master.getObjectID()!=null)
		System.out.println(master.getObjectID());
	    else 
		System.out.println("Master is null");
	    if(uc.getObjectID()==null)
		System.out.println("User context is null");
	    else
		System.out.println(uc.getObjectID());

  	}
  	catch (Exception ucex) {
  	    System.out.println(ucex);
	}

	/* Now add Charon module to slave server */
    	System.out.println("About to start Charon");
  	och=master.addNewModule("Charon");
    	//och=uc.addNewModule("Charon");
    	charon=CharonServerHelper.narrow(och);
   	charon.test();

 	//Set the ID on the server-side.
 	charon.setKerberosID(UserName);
  	System.out.println("Remote get:"+ charon.getKerberosID());
	//    	callServlet(servletURL,charon.getKerberosID());
	
	startBrowser();
    }
    
    public void initializeORB(String IorURL) { 
	//The following has been modified to set up the Orbasec orb and start
	//the necessary security services.

	//java.util.Properties props = new java.util.Properties();
	Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "orbasec.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	System.setProperties(props);

	String[] args = new String[1];
	args[0]=IorURL;
	orb=org.omg.CORBA.ORB.init(args,props);

	/*Now set the ORB's security attributes.  --Marlon */
	try{
	    security_manager = 
		org.omg.SecurityLevel2.SecurityManagerHelper.narrow(
							    orb.resolve_initial_references("SecurityManager"));
	    
	} 
	catch(Exception ex) {
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
	
	//
	// Authenticate using PrincipalAuthenticator
	//
	System.out.println("PrincipalAuthenticator is Started!!!!!!!!!\n");
	
	org.omg.SecurityLevel2.PrincipalAuthenticator pa;
	pa = security_manager.principal_authenticator();
	
	String  mechanism = "Kerberos";
	String security_name="";
	int method = orbasec.SecLev2.SecKerberosSession.value;
	orbasec.SecLev2.KerberosSession data=
	    orbasec.corba.AuthUtil.default_KerberosSession();
	data.config="FILE:/home/scri97/users/cyoun/birch/projectsk/cyoun/Kerberos/krb5-1.0.6/etc/krb5.conf";
	data.cache_name="";
	org.omg.CORBA.Any auth_data=orb.create_any();
	orbasec.SecLev2.KerberosSessionHelper.insert(auth_data,data);
	
	org.omg.Security.SecAttribute privileges[]=
	    new org.omg.Security.SecAttribute[0];
	org.omg.SecurityLevel2.CredentialsHolder creds=
	    new org.omg.SecurityLevel2.CredentialsHolder();
	org.omg.CORBA.AnyHolder
	    continuation_data=
	    new org.omg.CORBA.AnyHolder(),
	    auth_specific_data=
	    new org.omg.CORBA.AnyHolder();

	pa.authenticate(
			method,
			mechanism,
			security_name,
			auth_data,
			privileges,
			creds,
			continuation_data,
			auth_specific_data
			);
       
	System.out.println("PrincipalAuthenticator is ended!!!!!!!!!\n");
       
	/////////////////////////////////Added////////////////////////////////
	/*------------------------------------------------------------- 
	 * Grab user's name and principle from kerberos credentials. Note
	 * that the string comes with extra spaces, so these have to be
	 * trimmed away so that CORBA will not choke on them when you make
	 * remote calls.  --Marlon
	 */
	UserName=orbasec.corba.CredUtil.getSecurityName(security_manager.own_credentials()[0]);
	int length=0;
	StringTokenizer t=new StringTokenizer(UserName,"/@");
	UserName=t.nextToken();
	UserName.trim();
    }  
    
    public WebFlowContext getMasterServer(String IorURL){
	WebFlowContext ws = null;
	try {
	    String masterIOR = getIORFromURL(IorURL);
	    o_base = orb.string_to_object(masterIOR);
	    ws = WebFlowContextHelper.narrow(o_base);
	}
	catch (Exception e) {System.out.println("getMasterServer: "+e);}
	return ws;
    }
    
    public String getIORFromURL(String urlString){
	String masterServerIOR="";
	String thisLine=null;
	try {
	    URL u = new URL(urlString);
	    try {
		DataInputStream theHTML = new DataInputStream(u.openStream());
		try {
		    while ((thisLine = theHTML.readLine()) != null) {
			masterServerIOR += thisLine;
		    } 
		} 
		catch (Exception e) {
		    System.out.println("getIORfromURL:"+e);
		}
	    } 
	    catch (Exception e) {
		System.out.println("getIORfromURL:"+e);
	    }
	    
	} 
	catch (MalformedURLException e) {
	    System.out.println("getIORfromURL:"+urlString + " is not a parseable URL");
	    System.out.println("getIORfromURL:"+e);
	}
	return masterServerIOR;
    }

    public void startBrowser() {
	String session=charon.getKerberosID();
	try {
	    String path=BrowserPath+" "+LocalServer+startPage;
	    System.out.println(path);
	    Process p=Runtime.getRuntime().exec(path);
	}
	catch (IOException e) {
	    System.out.println(e);
	}
    }
    
    public void callServlet(String servletURL,String ID) {
	//***Obsolete***
	//This method writes all the needed login information to
	//a startup page specifiec by servletURL.  
	String session=ID; 
	try {
	    System.out.println(servletURL);
	    
	    URL url=new URL(servletURL);  
	    URLConnection conn=url.openConnection();
  	    conn.setDoOutput(true);
  	    conn.setDefaultUseCaches(false);
  	    conn.setUseCaches(false);
	    
	    PrintWriter out=
		new PrintWriter(conn.getOutputStream());
	    out.close();

	    BufferedReader in;
	    in = 
		new BufferedReader(new InputStreamReader(conn.getInputStream()));
	    StringBuffer response = new StringBuffer();
	    String line;
	    
	    while ((line = in.readLine()) != null)
		response.append(line + "\n");
	    System.out.println("Returning from callServlet()");	    
	}
	
	catch(Exception e) {
	    System.out.println(e);
	}
    }
    
    public void startSlaveServer(String ConfFile) {
	//Define the command line.  Note that you want to execute xterm 
	//remotely, as killing the xterm will kill all of the remote 
	//processes as well, cleaning up for you.  --Marlon
	
	cmd_line="xterm -sb -d "+DISPLAY+" -title "+UserName+" -e java WebFlow.Server "+ConfFile+" -SL2IIOP client";

	System.out.println(cmd_line);
	
	try {
	    Process p=Runtime.getRuntime().exec(cmd_line);
	}
	catch(Exception ex) {
	    System.err.println("Error in starting WebFlow Slave Server: "+ex);
	}
    }

    public void createSlaveConf(String ConfFile,String UserName,String Master)
    {
	//This method calls a servlet that creates the conf file for 
	//the user on the server side.  This conf file is then used
	//by the startSlaveServer method.
	
	
	System.out.println("I'm in cSC and master= "+Master);
	String confUrl=TargetServer+"/SciPortal/servlet/ConfWriteServ";
	try{
	    URL url=new URL(confUrl);
	    URLConnection conn=url.openConnection();
	    conn.setDoOutput(true);

	    PrintWriter out=
		new PrintWriter(conn.getOutputStream());
	    out.print("ConfFile"+"="+URLEncoder.encode(ConfFile));
	    out.print("&UserName"+"="+URLEncoder.encode(UserName));
	    out.print("&master"+"="+URLEncoder.encode(Master));
	    out.close();

	    BufferedReader in;
	    in=new BufferedReader(new InputStreamReader(conn.getInputStream()));
	    StringBuffer response=new StringBuffer();
	    String line;
	    
	    while ((line = in.readLine()) != null)
		response.append(line + "\n");
	    System.out.println("Returning from callServlet()");	    
	}
	
	catch(Exception e) {
	    System.out.println(e);
	}
	
    }
    
    public synchronized void waitForServer(long delay){
        System.err.println("waiting...");
        try {
	    wait(delay);
        } catch(InterruptedException e){
	    System.out.println("Intrrupted exc :"+e);
        }
    }

}
	


